/*
 * await.c --
 * "Time-sharing citizenry" support for VI2.3/VM1.2 (Sun-3 only)
 *		14-Oct-88 Allan M. Schiffman, ParcPlace Systems
 *
 * All this primitive does is invoke the Unix "pause" system call.
 * What pause does is wait until some Unix signal occurs, then return.
 * Since any mouse, keyboard or timer activity will trigger a signal,
 * (in VM1.2 on Sun-3s!)
 * this primitive can be used by the caller to do the Unix
 * equivalent of a Smalltalk "Processor yield", that is, give other
 * (Unix)processes a chance to use CPU cycles.
 * 
 */
#include "userprim.h"

#if 0
char *UPinstall();
char * (*UPinstallCode)() = UPinstall;
#endif

/*
 * <primitive: -3> (InputState class)await
 * Wait for some input or timer activity.  Returns self.  Cannot fail.
 */
upHandle
primAwait(receiver)
  upHandle receiver;
{
	UPbegin(receiver, 0);

	/* wait for any Unix signal */
	pause();
	/* some activity occurred, return to VI */

	UPreturnHandle(receiver);
}

char *
UPinstall()
{
	UPaddPrimitive(-3, primAwait, 0);
	return "Time-sharing citizenry mod";
}
